<template>
  <transition name="scale-fade">
    <div
      class="myBets_popup"
      v-if="visible">
      <div class="myBets_popup_inner">
        <div class="myBets_popup-header">
          <div
            class="myBets_popup-close"
            @click="$emit('close')">
            <i class="i-icon-close"></i>
          </div>
        </div>
        <div class="myBets_popup-number">
          <div
            class="myBets_popup-number-item betNumber"
            :style="calcStyles(cell)">
            <div
              class="betNumber_inner"
              :style="calcInnerStyles(cell)">
              <div
                class="betNumber_inner-helper"
                :style="calcHelperStyles(cell)">
                {{cell.key}}
              </div>
            </div>
          </div>
        </div>
        <div class="myBets_popup-body">
          <div class="flex flex-middle flex-around">
            <div class="flex flex_column" style="width: 60px;">
              <div
                class="myBets_popup-body-title"
                :class="bet > _diffBet() ? 'myBets_popup-body-title-red' : ''">
                {{bet > _diffBet() ? $t('common.maxBet') : $t('common.bet')}}
              </div>
              <div class="color-white myBets_popup-body-amount">
                <span>{{availableMaxBet}}</span> <span style="font-size: 12px;">EOS</span>
              </div>
            </div>
            <div class="myBets_popup-body-multiplier info-mockup">
              x{{multiplier}}
            </div>
            <div class="flex flex_column" style="width: 60px;">
              <div class="myBets_popup-body-title">
                {{$t('common.win')}}
              </div>
              <div class="color-green myBets_popup-body-amount"><span>{{parseInt((bet*multiplier) * 100)/100}}</span> <span style="font-size: 12px;">EOS</span></div>
            </div>
          </div>
          <div class="myBets_popup-body-btn flex flex-middle flex-center">
            <Btn @click="confirm">{{$t("playTable.clickToBet")}}</Btn>
          </div>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
  import Btn from '~/components/UI/BtnSign';
  import {waitingCellStorage} from "../utils/waitingCellStorage";
  import {flooring} from "../utils";

  const calcBackground = (cell, style = 'background') => {
    return cell[style] ? 'background: ' + cell[style] + ';' : '';
  };
  const calcBorder = (cell, style = 'borderColor') => {
    return cell[style] ? 'border-color: ' + cell[style] + ';' : '';
  };
  const calcBorderWidth = (cell, style = 'borderWidth', width) => {
    return !width ? cell[style] ? 'border-width: ' + cell[style] + 'px;' : '' : 'border-width: ' + width + 'px;';
  };
  const calcShadow = (cell, style = 'shadow') => {
    return cell[style] ? 'box-shadow: ' + cell[style] + ';' : '';
  };
  const calcFontColor = (cell, style = 'color') => {
    return cell[style] ? 'color: ' + cell[style] + ';' : '';
  };

  export default {
    name: "popup",
    data() {
      return {
        visible: false,
        multiplier: 15,
        cell: {},
        diffBet: 0
      }
    },
    components: {
      Btn
    },
    computed: {
      availableMaxBet() {
        return this.bet > (this.diffBet) ? parseInt((this.diffBet) * 100) / 100 : this.bet;
      },
      balance() {
        return this.$store.state.wallet.balance;
      },
      bet() {
        return Math.min(this.balance, this.$store.state.game.betAmount);
      },
      capByCellTotal() {
        return this.$store.state.game.settings.cap / 24;
      },
      capByCell() {
        return this.$store.state.game.settings.cell_limit;
      }
    },
    methods: {
      _diffBet() {
        return Math.min(flooring(this.capByCellTotal - this.cell.amount), flooring(this.capByCell - waitingCellStorage.getDiffForBet({
          number: this.cell.key,
          username: localStorage.getItem('accountname')
        })));
      },
      show(show, cell) {
        if (show) {
          let multiplier = 15;
          if (cell.connected && cell.connected.length) {
            multiplier = 15 / cell.connected.length;
          }
          this.multiplier = multiplier;
          this.cell = cell;
          this.diffBet = this._diffBet();
        }
        this.visible = show;
      },
      confirm() {
        this.ga('cl', true);
        let amount = flooring(this.bet);
        if (this.bet > (this.diffBet)) {
          amount = flooring(this.diffBet);
        }
        this.show(false, {});
        this.$nextTick(_ => {
          this.$emit('confirm', {
            cell: Object.assign({multiplier: this.multiplier}, this.cell),
            amount: amount
          });
        });
      },
      calcHelperStyles(cell) {
        let style = '';
        style += calcBackground(cell, 'backgroundInner');
        style += calcFontColor(cell, 'color');
        return style;
      },
      calcInnerStyles(cell) {
        let style = '';
        style += calcBackground(cell, 'gradientInner');
        style += calcShadow(cell, 'shadowInner');
        style += calcFontColor(cell, 'color');
        return style;
      },
      calcStyles(cell) {
        let style = '';
        style += calcBackground(cell);
        style += calcBorder(cell);
        style += calcShadow(cell);
        style += calcBorderWidth(cell);
        return style;
      },
    }
  }
</script>
